<?php
/**
 * @file
 */

class more_boxes_imce extends boxes_box {
  /**
   * Implementation of boxes_box::options_defaults().
   */
  public function options_defaults() {
    return array(
      'link_url' => '',
      'imce_image_path' => '',
      'imce_flash_path' => '',
    );
  }

  /**
   * Implementation of boxes_box::options_form().
   */
  public function options_form(&$form_state) {
    $form = array();
    $form['link_url'] = array(
      '#type' => 'textfield',
      '#title' => t('Link URL'),
      '#default_value' => $this->options['link_url'],
    );
    $form['imce_image_path'] = array(
      '#type' => 'textfield',
      '#title' => t('Image path'),
      '#default_value' => $this->options['imce_image_path'],
      '#suffix' => '<div class="imce-browser-ph"><a href="#">' . t('Browse') . '</a></div>',
    );
    $form['imce_flash_path'] = array(
      '#type' => 'textfield',
      '#title' => t('Flash path'),
      '#default_value' => $this->options['imce_flash_path'],
      '#suffix' => '<div class="imce-browser-ph"><a href="#">' . t('Browse') . '</a></div>',
    );

    return $form;
  }

  /**
   * Implementation of boxes_box::render().
   */
  public function render() {
    $title = isset($this->title) ? check_plain($this->title) : NULL;
    $block['title'] = $title;
    $block['subject'] = NULL;
    $block['delta'] = $this->delta;
    $link_options = array('html' => TRUE);
       
    if ($this->options['imce_flash_path']) {
      $swf_path = url($this->options['imce_flash_path'], array('absolute' => TRUE));
      $content = '<embed name="plugin" src="' . $swf_path . '" type="application/x-shockwave-flash">';
    }
    elseif ($this->options['imce_image_path']) {
      $image_path = substr($this->options['imce_image_path'], strlen(base_path()));
      $image = theme('image', array('path' => $image_path, 'alt' => $title, 'title' => $title));
      $content = l($image, $this->options['link_url'], $link_options);
    }
    
    $block['content'] = $content;
    return $block;
  }
}