(function($) {
  Drupal.behaviors.imceBoxes = {
    attach: function(context) {
      $('.imce-browser-ph', context).click(function(){
        window.open(Drupal.settings.basePath+'imce?app=myApp|url%40edit-imce-image-path', '', 'width=760,height=560, resizable=1', '', '', '', 'ff');
      });
    }
  }
  
  Drupal.behaviors.imageGallery = {
    attach: function(context) {
    
      // Create the Image Gallery

      // Show only the first image (the others are hidden by css)
      $('.block-boxes-node_images_box .field-item:first-child img').show();
      // Add html for the caption and pager
      var captionBox = '<div class="gallery-caption"></div>';
      var pagerBox = '<div class="gallery-pager"></div>';
      $('.block-boxes-node_images_box .boxes-box-content').append(captionBox);
      $('.block-boxes-node_images_box .boxes-box-content').append(pagerBox);
      $('.block-boxes-node_images_box .gallery-caption').html($('.block-boxes-node_images_box .field-item:first-child img').attr('alt'));
      var pager = '';
      $('.block-boxes-node_images_box .field-item').each(function(index) {
          if (index == 0) {
            pager = pager + '<div class="pager-item active"><a href="#" id="0"></a></div>';
          }
          else {
            pager = pager + '<div class="pager-item"><a href="#" id="' + index + '"></a></div>';
          }
      });
      $('.block-boxes-node_images_box .gallery-pager').html(pager);

      // Deal with over 10 items in the pager 

          // Some constants:
      var maxPaged = 10;
      var pagedWidth = 17;

      var numPics = $(".block-boxes-node_images_box .field-item").length;
      if (numPics > maxPaged) {
        $('.block-boxes-node_images_box .gallery-pager').wrap('<div class="scrolled-gallery" />');
        $('.block-boxes-node_images_box .gallery-pager').wrap('<div class="gallery-wrapper" />');
        $('.block-boxes-node_images_box .scrolled-gallery').prepend('<div class="prev inactive">&gt;</div>');
        $('.block-boxes-node_images_box .scrolled-gallery').prepend('<div class="next">&lt;</div>');
      }

      // Click-on-pager functionality
      $('.block-boxes-node_images_box .gallery-pager .pager-item').click(function(e){
        $('.block-boxes-node_images_box .field-item img').hide();
        $('.block-boxes-node_images_box .field-type-image .field-item:nth-child(' + (Number($('a', this).attr('id')) + 1) + ') img').show();
        $(this).siblings().removeClass('active');
        $(this).addClass('active');
      });

      var clicksNext = 0;
      var maxClicks = numPics - maxPaged + 2;
      var margin = 0;
      // Click-on-next functionality
      $('.block-boxes-node_images_box .scrolled-gallery .next').click(function(e){
        if (clicksNext < maxClicks) {
          clicksNext++;
          margin = margin - pagedWidth;
          $('.block-boxes-node_images_box .gallery-pager').css('margin-left', margin);
          $('.block-boxes-node_images_box .scrolled-gallery .prev').removeClass('inactive');
        }
        if (clicksNext == maxClicks) {
          $(this).addClass('inactive');
        }
      });

      // Click-on-prev functionality
      $('.block-boxes-node_images_box .scrolled-gallery .prev').click(function(e){
        if (clicksNext + maxPaged - 2 <= numPics && clicksNext > 0) {
          clicksNext--;
          margin = margin + pagedWidth;
          $('.block-boxes-node_images_box .gallery-pager').css('margin-left', margin);
          $('.block-boxes-node_images_box .scrolled-gallery .next').removeClass('inactive');
        }
        if (clicksNext == 0) {
          $(this).addClass('inactive');
        }
      });

    }
  }
  
  Drupal.behaviors.moreBoxMinimise = {
    attach: function(context) {    
      $(".form-item-body-format").append('<a class="fieldset-legend">Tips</a>'); 
      $(".form-item-body-format a").toggle(function(){
        $("#edit-body-format-guidelines").slideDown(200); 
      }, 
      function(){
        $("#edit-body-format-guidelines").slideUp(200); 
      });   
    }
  }

  // DUPLICATE AND UNCOMMENT
  // Drupal.behaviors.behaviorName = {
  //  attach: function(context) {
  //    // Do some magic...
  //  }
  // };


})(jQuery);
